(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common/http'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('atom-httpclient', ['exports', '@angular/common/http', '@angular/core'], factory) :
    (factory((global['atom-httpclient'] = {}),global.ng.common.http,global.ng.core));
}(this, (function (exports,http,core) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AtomHttpclientService = /** @class */ (function () {
        function AtomHttpclientService(client) {
            this.client = client;
            this.httpClient = client;
        }
        /**
         *
         *  Http request to the web service
         * @param url The endpoint e. login
         * @param data The request data
         */
        /**
         *
         *  Http request to the web service
         * @param {?} url The endpoint e. login
         * @param {?} data The request data
         * @return {?}
         */
        AtomHttpclientService.prototype.Post = /**
         *
         *  Http request to the web service
         * @param {?} url The endpoint e. login
         * @param {?} data The request data
         * @return {?}
         */
            function (url, data) {
                return this.httpClient.post("" + url, data.requestPayload, { headers: data.headers });
            };
        /**
         *
         * @param url The endpoint for accessing the api
         * @param data The request data
         */
        /**
         *
         * @param {?} url The endpoint for accessing the api
         * @param {?} data The request data
         * @return {?}
         */
        AtomHttpclientService.prototype.Get = /**
         *
         * @param {?} url The endpoint for accessing the api
         * @param {?} data The request data
         * @return {?}
         */
            function (url, data) {
                if (data.requestParams == null) {
                    return this.httpClient.get("" + url, { headers: data.headers });
                }
                else {
                    return this.httpClient.get("" + url, { headers: data.headers, params: data.requestParams });
                }
            };
        /**
         *
         *
         *
         * @param url The endpoint
         * @param data The request data
         */
        /**
         *
         *
         *
         * @param {?} url The endpoint
         * @param {?} data The request data
         * @return {?}
         */
        AtomHttpclientService.prototype.Put = /**
         *
         *
         *
         * @param {?} url The endpoint
         * @param {?} data The request data
         * @return {?}
         */
            function (url, data) {
                return this.httpClient.put("" + url, data.requestPayload, { headers: data.headers });
            };
        /**
         *
         *
         * @param url The url
         * @param data The request
         */
        /**
         *
         *
         * @param {?} url The url
         * @param {?} data The request
         * @return {?}
         */
        AtomHttpclientService.prototype.Delete = /**
         *
         *
         * @param {?} url The url
         * @param {?} data The request
         * @return {?}
         */
            function (url, data) {
                if (data.requestParams == null) {
                    return this.httpClient.delete("" + url, { headers: data.headers });
                }
                else {
                    return this.httpClient.delete("" + url, { headers: data.headers, params: data.requestParams });
                }
            };
        /**
         *
         *
         * @param url The url to call
         * @param data The data request
         */
        /**
         *
         *
         * @param {?} url The url to call
         * @param {?} data The data request
         * @return {?}
         */
        AtomHttpclientService.prototype.Patch = /**
         *
         *
         * @param {?} url The url to call
         * @param {?} data The data request
         * @return {?}
         */
            function (url, data) {
                return this.httpClient.patch("" + url, data.requestPayload, { headers: data.headers });
            };
        AtomHttpclientService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        AtomHttpclientService.ctorParameters = function () {
            return [
                { type: http.HttpClient }
            ];
        };
        return AtomHttpclientService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AtomHttpclientComponent = /** @class */ (function () {
        function AtomHttpclientComponent() {
        }
        /**
         * @return {?}
         */
        AtomHttpclientComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        AtomHttpclientComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-atom-httpclient',
                        template: "\n    <p>\n      atom-httpclient works!\n    </p>\n  "
                    }] }
        ];
        /** @nocollapse */
        AtomHttpclientComponent.ctorParameters = function () { return []; };
        return AtomHttpclientComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var /**
     * @abstract
     */ Environment = /** @class */ (function () {
        function Environment() {
        }
        return Environment;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AtomRestService = /** @class */ (function () {
        /**
         *
         *
         *
         * @param http The AtomHttpclientService
         * @param env  The environment
         */
        function AtomRestService(http$$1, env) {
            this.http = http$$1;
            this.env = env;
            if (env.ENV_VARIABLES.API_URL.endsWith('/')) {
                this.API_ENDPOINT_BASE_URL = env.ENV_VARIABLES.API_URL;
            }
            else {
                this.API_ENDPOINT_BASE_URL = env.ENV_VARIABLES.API_URL.concat('/');
            }
        }
        /**
         * Post request
         *
         *  Http request to the web service
         * @param endpoint The endpoint
         * @param data The request data
         */
        /**
         * Post request
         *
         *  Http request to the web service
         * @param {?} endpoint The endpoint
         * @param {?} data The request data
         * @return {?}
         */
        AtomRestService.prototype.Post = /**
         * Post request
         *
         *  Http request to the web service
         * @param {?} endpoint The endpoint
         * @param {?} data The request data
         * @return {?}
         */
            function (endpoint, data) {
                return this.http.Post("" + this.API_ENDPOINT_BASE_URL + endpoint, data);
            };
        /**
         *  Get request
         *
         * @param endpoint The endpoint for accessing the api
         * @param data The request data
         */
        /**
         *  Get request
         *
         * @param {?} endpoint The endpoint for accessing the api
         * @param {?} data The request data
         * @return {?}
         */
        AtomRestService.prototype.Get = /**
         *  Get request
         *
         * @param {?} endpoint The endpoint for accessing the api
         * @param {?} data The request data
         * @return {?}
         */
            function (endpoint, data) {
                return this.http.Get("" + this.API_ENDPOINT_BASE_URL + endpoint, data);
            };
        /**
         *
         *
         * Put
         * @param endpoint The endpoint
         * @param data The request data
         */
        /**
         *
         *
         * Put
         * @param {?} endpoint The endpoint
         * @param {?} data The request data
         * @return {?}
         */
        AtomRestService.prototype.Put = /**
         *
         *
         * Put
         * @param {?} endpoint The endpoint
         * @param {?} data The request data
         * @return {?}
         */
            function (endpoint, data) {
                return this.http.Put("" + this.API_ENDPOINT_BASE_URL + endpoint, data);
            };
        /**
         * Delete
         * @param endpoint The endpoint
         * @param data The request
         */
        /**
         * Delete
         * @param {?} endpoint The endpoint
         * @param {?} data The request
         * @return {?}
         */
        AtomRestService.prototype.Delete = /**
         * Delete
         * @param {?} endpoint The endpoint
         * @param {?} data The request
         * @return {?}
         */
            function (endpoint, data) {
                return this.http.Delete("" + this.API_ENDPOINT_BASE_URL + endpoint, data);
            };
        /**
         *
         *  Patch
         * @param endpoint The endpoint
         * @param data the data request
         */
        /**
         *
         *  Patch
         * @param {?} endpoint The endpoint
         * @param {?} data the data request
         * @return {?}
         */
        AtomRestService.prototype.Patch = /**
         *
         *  Patch
         * @param {?} endpoint The endpoint
         * @param {?} data the data request
         * @return {?}
         */
            function (endpoint, data) {
                return this.http.Patch("" + this.API_ENDPOINT_BASE_URL + endpoint, data);
            };
        AtomRestService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        AtomRestService.ctorParameters = function () {
            return [
                { type: AtomHttpclientService },
                { type: Environment }
            ];
        };
        return AtomRestService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AtomHttpclientModule = /** @class */ (function () {
        function AtomHttpclientModule() {
        }
        AtomHttpclientModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [AtomHttpclientComponent],
                        imports: [
                            http.HttpClientModule
                        ],
                        providers: [AtomHttpclientService, AtomRestService],
                        exports: []
                    },] }
        ];
        return AtomHttpclientModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.AtomHttpclientService = AtomHttpclientService;
    exports.AtomHttpclientModule = AtomHttpclientModule;
    exports.Environment = Environment;
    exports.AtomRestService = AtomRestService;
    exports.ɵa = AtomHttpclientComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=atom-httpclient.umd.js.map