import { HttpClient, HttpClientModule } from '@angular/common/http';
import { Injectable, Component, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AtomHttpclientService {
    /**
     * @param {?} client
     */
    constructor(client) {
        this.client = client;
        this.httpClient = client;
    }
    /**
     *
     *  Http request to the web service
     * @param {?} url The endpoint e. login
     * @param {?} data The request data
     * @return {?}
     */
    Post(url, data) {
        return this.httpClient.post(`${url}`, data.requestPayload, { headers: data.headers });
    }
    /**
     *
     * @param {?} url The endpoint for accessing the api
     * @param {?} data The request data
     * @return {?}
     */
    Get(url, data) {
        if (data.requestParams == null) {
            return this.httpClient.get(`${url}`, { headers: data.headers });
        }
        else {
            return this.httpClient.get(`${url}`, { headers: data.headers, params: data.requestParams });
        }
    }
    /**
     *
     *
     *
     * @param {?} url The endpoint
     * @param {?} data The request data
     * @return {?}
     */
    Put(url, data) {
        return this.httpClient.put(`${url}`, data.requestPayload, { headers: data.headers });
    }
    /**
     *
     *
     * @param {?} url The url
     * @param {?} data The request
     * @return {?}
     */
    Delete(url, data) {
        if (data.requestParams == null) {
            return this.httpClient.delete(`${url}`, { headers: data.headers });
        }
        else {
            return this.httpClient.delete(`${url}`, { headers: data.headers, params: data.requestParams });
        }
    }
    /**
     *
     *
     * @param {?} url The url to call
     * @param {?} data The data request
     * @return {?}
     */
    Patch(url, data) {
        return this.httpClient.patch(`${url}`, data.requestPayload, { headers: data.headers });
    }
}
AtomHttpclientService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
AtomHttpclientService.ctorParameters = () => [
    { type: HttpClient }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AtomHttpclientComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
AtomHttpclientComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-atom-httpclient',
                template: `
    <p>
      atom-httpclient works!
    </p>
  `
            }] }
];
/** @nocollapse */
AtomHttpclientComponent.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
class Environment {
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AtomRestService {
    /**
     *
     *
     *
     * @param {?} http The AtomHttpclientService
     * @param {?} env  The environment
     */
    constructor(http, env) {
        this.http = http;
        this.env = env;
        if (env.ENV_VARIABLES.API_URL.endsWith('/')) {
            this.API_ENDPOINT_BASE_URL = env.ENV_VARIABLES.API_URL;
        }
        else {
            this.API_ENDPOINT_BASE_URL = env.ENV_VARIABLES.API_URL.concat('/');
        }
    }
    /**
     * Post request
     *
     *  Http request to the web service
     * @param {?} endpoint The endpoint
     * @param {?} data The request data
     * @return {?}
     */
    Post(endpoint, data) {
        return this.http.Post(`${this.API_ENDPOINT_BASE_URL}${endpoint}`, data);
    }
    /**
     *  Get request
     *
     * @param {?} endpoint The endpoint for accessing the api
     * @param {?} data The request data
     * @return {?}
     */
    Get(endpoint, data) {
        return this.http.Get(`${this.API_ENDPOINT_BASE_URL}${endpoint}`, data);
    }
    /**
     *
     *
     * Put
     * @param {?} endpoint The endpoint
     * @param {?} data The request data
     * @return {?}
     */
    Put(endpoint, data) {
        return this.http.Put(`${this.API_ENDPOINT_BASE_URL}${endpoint}`, data);
    }
    /**
     * Delete
     * @param {?} endpoint The endpoint
     * @param {?} data The request
     * @return {?}
     */
    Delete(endpoint, data) {
        return this.http.Delete(`${this.API_ENDPOINT_BASE_URL}${endpoint}`, data);
    }
    /**
     *
     *  Patch
     * @param {?} endpoint The endpoint
     * @param {?} data the data request
     * @return {?}
     */
    Patch(endpoint, data) {
        return this.http.Patch(`${this.API_ENDPOINT_BASE_URL}${endpoint}`, data);
    }
}
AtomRestService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
AtomRestService.ctorParameters = () => [
    { type: AtomHttpclientService },
    { type: Environment }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AtomHttpclientModule {
}
AtomHttpclientModule.decorators = [
    { type: NgModule, args: [{
                declarations: [AtomHttpclientComponent],
                imports: [
                    HttpClientModule
                ],
                providers: [AtomHttpclientService, AtomRestService],
                exports: []
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AtomHttpclientService, AtomHttpclientModule, Environment, AtomRestService, AtomHttpclientComponent as ɵa };

//# sourceMappingURL=atom-httpclient.js.map