import { Observable } from 'rxjs';
import { HttpClient } from '@angular/common/http';
import { IRequest, IResponse } from './atom-httpclient.models';
export declare class AtomHttpclientService {
    private client;
    private httpClient;
    constructor(client: HttpClient);
    /**
     *
     *  Http request to the web service
     * @param url The endpoint e. login
     * @param data The request data
     */
    Post(url: string, data: IRequest): Observable<IResponse>;
    /**
     *
     * @param url The endpoint for accessing the api
     * @param data The request data
     */
    Get(url: string, data: IRequest): Observable<IResponse>;
    /**
     *
     *
     *
     * @param url The endpoint
     * @param data The request data
     */
    Put(url: string, data: IRequest): Observable<IResponse>;
    /**
     *
     *
     * @param url The url
     * @param data The request
     */
    Delete(url: string, data: IRequest): Observable<IResponse>;
    /**
     *
     *
     * @param url The url to call
     * @param data The data request
     */
    Patch(url: string, data: IRequest): Observable<IResponse>;
}
