import { Environment, IRequest, IResponse } from './atom-httpclient.models';
import { Observable } from 'rxjs';
import { AtomHttpclientService } from './atom-httpclient.service';
export declare class AtomRestService {
    private http;
    private env;
    API_ENDPOINT_BASE_URL: string;
    /**
     *
     *
     *
     * @param http The AtomHttpclientService
     * @param env  The environment
     */
    constructor(http: AtomHttpclientService, env: Environment);
    /**
     * Post request
     *
     *  Http request to the web service
     * @param endpoint The endpoint
     * @param data The request data
     */
    Post(endpoint: string, data: IRequest): Observable<IResponse>;
    /**
     *  Get request
     *
     * @param endpoint The endpoint for accessing the api
     * @param data The request data
     */
    Get(endpoint: string, data: IRequest): Observable<IResponse>;
    /**
     *
     *
     * Put
     * @param endpoint The endpoint
     * @param data The request data
     */
    Put(endpoint: string, data: IRequest): Observable<IResponse>;
    /**
     * Delete
     * @param endpoint The endpoint
     * @param data The request
     */
    Delete(endpoint: string, data: IRequest): Observable<IResponse>;
    /**
     *
     *  Patch
     * @param endpoint The endpoint
     * @param data the data request
     */
    Patch(endpoint: string, data: IRequest): Observable<IResponse>;
}
